Hardware Locality (hwloc) 2.2.0

Functions
Interoperability with the CUDA Runtime API

## Functions
static int | hwloc_cudart_get_device_pci_ids (hwloc_topology_t topology, int idx, int *domain, int *bus, int *dev)
static int | hwloc_cudart_get_device_cpuset (hwloc_topology_t topology, int idx, hwloc_cpuset_t set)
static hwloc_obj_t | hwloc_cudart_get_device_pcidev (hwloc_topology_t topology, int idx)
static hwloc_obj_t | hwloc_cudart_get_device_osdev_by_index (hwloc_topology_t topology, unsigned idx)

## Detailed Description

This interface offers ways to retrieve topology information about CUDA devices when using the CUDA Runtime API.

## Function Documentation

## ◆ hwloc_cudart_get_device_cpuset()

static int hwloc_cudart_get_device_cpuset | ( | hwloc_topology_t | topology,
|  | int | idx,
|  | hwloc_cpuset_t | set
| ) |  |
| inline static

Get the CPU set of logical processors that are physically close to device `idx`.

Return the CPU set describing the locality of the CUDA device whose index is `idx`.

Topology `topology` and device `idx` must match the local machine. I/O devices detection and the CUDA component are not needed in the topology.

The function only returns the locality of the device. If more information about the device is needed, OS objects should be used instead, see hwloc_cudart_get_device_osdev_by_index().

This function is currently only implemented in a meaningful way for Linux; other systems will simply get a full cpuset.

## ◆ hwloc_cudart_get_device_osdev_by_index()

static hwloc_obj_t hwloc_cudart_get_device_osdev_by_index | ( | hwloc_topology_t | topology,
|  | unsigned | idx
| ) |  |
| inline static

Get the hwloc OS device object corresponding to the CUDA device whose index is `idx`.

Return the OS device object describing the CUDA device whose index is `idx`. Return NULL if there is none.

The topology `topology` does not necessarily have to match the current machine. For instance the topology may be an XML import of a remote host. I/O devices detection and the CUDA component must be enabled in the topology. If not, the locality of the object may still be found using hwloc_cudart_get_device_cpuset().

Note
  The corresponding PCI device object can be obtained by looking at the OS device parent object (unless PCI devices are filtered out).
  This function is identical to hwloc_cuda_get_device_osdev_by_index().

## ◆ hwloc_cudart_get_device_pci_ids()

static int hwloc_cudart_get_device_pci_ids | ( | hwloc_topology_t | topology,
|  | int | idx,
|  | int * | domain,
|  | int * | bus,
|  | int * | dev
| ) |  |
| inline static

Return the domain, bus and device IDs of the CUDA device whose index is `idx`.

Device index `idx` must match the local machine.

## ◆ hwloc_cudart_get_device_pcidev()

static hwloc_obj_t hwloc_cudart_get_device_pcidev | ( | hwloc_topology_t | topology,
|  | int | idx
| ) |  |
| inline static

Get the hwloc PCI device object corresponding to the CUDA device whose index is `idx`.

Return the PCI device object describing the CUDA device whose index is `idx`. Return NULL if there is none.

Topology `topology` and device `idx` must match the local machine. I/O devices detection must be enabled in topology `topology`. The CUDA component is not needed in the topology.